"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var readEvents = function () { return __awaiter(void 0, void 0, void 0, function () {
    var currentPath, pathfile, content;
    return __generator(this, function (_a) {
        try {
            currentPath = process.cwd();
            pathfile = path_1.default.join(currentPath, "temp", "output.txt");
            content = fs_1.default.readFileSync(pathfile, "utf-8");
            return [2 /*return*/, content];
        }
        catch (error) {
            console.error("Ocorreu um erro: ", error);
            return [2 /*return*/, ""];
        }
        return [2 /*return*/];
    });
}); };
function parseEvents(output) {
    return __awaiter(this, void 0, void 0, function () {
        var logsStartKeyword, logsEndKeyword, errorIndex, logsStartIndex, logsEndIndex, errorReason, logs;
        return __generator(this, function (_a) {
            logsStartKeyword = "====== logs ======";
            logsEndKeyword = "============================================================";
            errorIndex = output.indexOf("✖ ");
            logsStartIndex = output.indexOf(logsStartKeyword);
            logsEndIndex = output.indexOf(logsEndKeyword, logsStartIndex);
            errorReason = output.slice(errorIndex + 2, logsStartIndex).trim();
            logs = output
                .slice(logsStartIndex + logsStartKeyword.length, logsEndIndex)
                .trim();
            if (errorReason && errorReason.includes("Timeout")) {
                console.error("\n\n", "##vso[task.logissue type=warning] Causa do Erro", "\n", "##vso[task.logissue type=warning]" + errorReason);
                console.error("\n\n", "##vso[task.logissue type=warning] Possível solução", "\n", "##vso[task.logissue type=warning] https:playwright.com");
            }
            return [2 /*return*/, { errorReason: errorReason, logs: logs }];
        });
    });
}
var executeEvents = function () { return __awaiter(void 0, void 0, void 0, function () {
    var output;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, readEvents()];
            case 1:
                output = _a.sent();
                if (!(output.length > 0)) return [3 /*break*/, 3];
                return [4 /*yield*/, parseEvents(output)];
            case 2:
                _a.sent();
                return [3 /*break*/, 4];
            case 3:
                console.log("Arquivo vazio", output);
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
executeEvents();
